#!/bin/sh
# TODO:
# - Alguna manera de buscar el lenguaje del sistema para pasarlo en set_lang
# - Extraer fichero y automatizar el proceso de instalación descrito en:
#   https://fran.cr/instalar-firma-digital-costa-rica-gnu-linux-ubuntu-debian/

urlencode() {
    ENCODEDURL="$(tr -d '\n' | curl -Gs -w %{url_effective} --data-urlencode @- ./ ||: | sed "s/%0[aA]$//;s/^[^?]*?\(.*\)/\1/")"
    printf '%s' "$ENCODEDURL" | sed 's/^http.*?//g'
}

get_asp_var() {
    VARS="$@" ; i=0
    for VAR in $VARS ; do
        VAL="$(printf '%s' "$RESPONSE" | grep -o "id=\"$VAR\"\svalue=\".*\"" | cut -d '"' -f 4 | urlencode)"
        [ "$i" != 0 ] && printf '&'
        printf '%s=%s' "$VAR" "$VAL"
        i=+1
    done
}

download_iso() {
    SN="$1"
    URL="https://soportefirmadigital.com/sfdj/dl.aspx"

    alias curl="curl \
        -H 'Pragma: no-cache' \
        -H 'Connection: keep-alive' \
        -H 'Cache-Control: no-cache' \
        -H 'Upgrade-Insecure-Requests: 1' \
        -H 'User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:109.0) Gecko/20100101 Firefox/128.0' \
        -H 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,image/avif,image/webp,*/*;q=0.8' \
        -H 'Accept-Encoding: gzip, deflate, br' \
        -H 'Accept-Language: es-ES,es;q=0.8,en-US;q=0.5,en;q=0.3' \
        -H 'Referer: https://www.soportefirmadigital.com/sfdj/dl.aspx?lang=en' \
        -H 'Content-Type: application/x-www-form-urlencoded' \
        -H 'Sec-Fetch-Dest: document' \
        -H 'Sec-Fetch-Mode: navigate' \
        -H 'Sec-Fetch-Site: same-origin' \
        -H 'Sec-Fetch-User: ?1' \
    "

    RESPONSE="$(curl -s --compressed "$URL" -o -)"

    ASP_VARS="$(get_asp_var __VIEWSTATE __VIEWSTATEGENERATOR __EVENTVALIDATION)"
    RESPONSE="$(curl -Ls --compressed "$URL" \
        --data-raw "__EVENTTARGET=ctl00%24certContents%24ddlInstaladores" \
        --data-raw "__EVENTARGUMENT=" \
        --data-raw "__LASTFOCUS=" \
        --data-raw "$ASP_VARS" \
        --data-raw "ctl00%24certContents%24hiddenISO=Windows_rev62.exe" \
        --data-raw "ctl00%24certContents%24hidden_ISO_URL=-" \
        --data-raw "ctl00%24certContents%24txtSerialNumber=" \
        --data-raw "ctl00%24certContents%24ddlInstaladores=$ddlInstaladores" \
        --data-raw "ctl00%24certContents%24txtDescripcion=$txtDescripcion" \
        --data-raw "ctl00%24certContents%24chkConfirmo=" \
        --data-raw "ctl00%24certContents%24hiddenABID=" \
        -o -)"

    ASP_VARS="$(get_asp_var __VIEWSTATE __VIEWSTATEGENERATOR __EVENTVALIDATION)"
    RESPONSE="$(curl -H "Set-Cookie: SN=$SN" -s --compressed "$URL" \
        --cookie "SN=$SN" \
        --data-raw "__EVENTTARGET=ctl00%24certContents%24LinkButton3" \
        --data-raw "__EVENTARGUMENT=" \
        --data-raw "__LASTFOCUS=" \
        --data-raw "$ASP_VARS" \
        --data-raw "ctl00%24certContents%24hiddenISO=$hiddenISO" \
        --data-raw "ctl00%24certContents%24hidden_ISO_URL=-" \
        --data-raw "ctl00%24certContents%24txtSerialNumber=$SN" \
        --data-raw "ctl00%24certContents%24ddlInstaladores=$ddlInstaladores" \
        --data-raw "ctl00%24certContents%24txtDescripcion=$txtDescripcion" \
        --data-raw "ctl00%24certContents%24chkConfirmo=on" \
        --data-raw "ctl00%24certContents%24hiddenABID=" \
        -o -)"

    printf '%s' "$RESPONSE"
}

set_file() {
    FILE="$1"

    [ "$FILE" = "ClientesMac_rev34.zip" ] && hiddenISO="ClientesMac_rev34.zip"
    [ "$FILE" = "ClientesMac_rev34.zip" ] && ddlInstaladores="Usuarios+MAC"
    [ "$FILE" = "ClientesMac_rev34.zip" ] && txtDescripcion="Drivers%2C+Certificados+y+Librerias+para+macOS%0D%0ASISTEMAS+OPERATIVOS+HOMOLOGADOS%0D%0A%0D%0AmacOSX+10.14+o+superior.%0D%0A%0D%0ASoporte+%C3%BAnicamente+en+m%C3%A1quinas+F%C3%ADsicas.%0D%0AMD5%3Aa0dee949d20b41a11ab6d4cc727d94bb"
    [ "$FILE" = "ClientesMac_rev34.zip" ] && SIZE=150252

    [ "$FILE" = "ClientesLinux_DEB64_Rev25.zip" ] && hiddenISO="ClientesLinux_DEB64_Rev25.zip"
    [ "$FILE" = "ClientesLinux_DEB64_Rev25.zip" ] && ddlInstaladores="Usuarios+Linux+%28DEB+64bits%29"
    [ "$FILE" = "ClientesLinux_DEB64_Rev25.zip" ] && txtDescripcion="Distribuciones+basadas+en+DEB+x64.%0D%0AVersiones+Homologadas%0D%0A-Ubuntu+18.04+LTS+o+superior%28solo+versiones+LTS%29%0D%0A-Debian+10%0D%0A%0D%0ASoporte+%C3%BAnicamente+en+m%C3%A1quinas+F%C3%ADsicas.%0D%0AMD5%3A3a8c11d0273daee7bfc63a17615a8dc9"
    [ "$FILE" = "ClientesLinux_DEB64_Rev25.zip" ] && SIZE=108200

    [ "$FILE" = "ClientesLinux_CentOS7_Rev6.zip" ] && hiddenISO="ClientesLinux_CentOS7_Rev6.zip"
    [ "$FILE" = "ClientesLinux_CentOS7_Rev6.zip" ] && ddlInstaladores="Usuarios+Linux+RPM+%28CentOS+7%29"
    [ "$FILE" = "ClientesLinux_CentOS7_Rev6.zip" ] && txtDescripcion="Distribuciones+basadas+en+RPM.%0D%0AVersiones+Homologadas%0D%0A-CentOS+7.%0D%0A%0D%0ASoporte+%C3%BAnicamente+en+m%C3%A1quinas+F%C3%ADsicas.%0D%0AMD5%3Aeae741aa8bf16e16a349f0e2ad3b7e64"
    [ "$FILE" = "ClientesLinux_CentOS7_Rev6.zip" ] && SIZE=114344

    [ "$FILE" = "ClientesLinux_RPM64_Rev24.zip" ] && hiddenISO="ClientesLinux_RPM64_Rev24.zip"
    [ "$FILE" = "ClientesLinux_RPM64_Rev24.zip" ] && ddlInstaladores="Usuarios+Linux+%28RPM+64bits%29"
    [ "$FILE" = "ClientesLinux_RPM64_Rev24.zip" ] && txtDescripcion="Distribuciones+basadas+en+RPM+x64.%0D%0AVersiones+Homologadas%0D%0A-Fedora+34+o+superior%0D%0A-CentOS+Stream+9+%0D%0A%0D%0ASoporte+%C3%BAnicamente+en+m%C3%A1quinas+F%C3%ADsicas.%0D%0AMD5%3A6180c4708fb183c8f452240a7c8c01d0"
    [ "$FILE" = "ClientesLinux_RPM64_Rev24.zip" ] && SIZE=114348
}

set_lang() {
    # See: /var/lib/AccountsService/users/
    [ -z "$SLANG" ] && SLANG="es"

    if [ "$SLANG" = "es" ] ; then
        TITLE="Instalador firma digital"

        PROMPT_WELCOME="Bienvenido al asistente de instalación de certificados para firma digial."

        PROMPT_FILE="Seleccione el fichero que corresponde a su sistema operativo."
        FILENAME="Archivo"
        FILEDESC="Sistema"

        PROMPT_SERIAL="Para continuar con la descarga del fichero del Centro de Soporte Firma Digital, por favor, ingrese el número serial que se encuentra al reverso de la tarjeta."
        PROMPT_ERR_SERIAL="Error al obtener el número serial de la tarjeta, abortando."
        PROMPT_ERR_DOWNLOAD="Error al descargar el fichero desde Centro de Soporte Firma Digital, abortando."

        PROMPT_DIR_FILE="A continuación, deberá seleccionar la carpeta donde quiere que se descargue y se extraigan los contenidos del fichero seleccionado"
        PROMPT_ERR_DIR_FILE="Error al seleccionar la carpeta de descarga para el fichero, abortando."

        PROMPT_DOWNLOAD="Descargando el fichero $FILE desde Centro de Soporte Firma Digital..."
        PROMPT_ERR_DOWN_FILE="Error al descargar el fichero, abortando."
    fi
    
    if [ "$SLANG" = "en" ] ; then
    fi

    if [ "$SLANG" = "fr" ] ; then
    fi
}

# main

set_lang

if [ -e "/bin/zenity" ] ; then
    # Welcome
    zenity --title "$TITLE" --text "$PROMPT_WELCOME" --info

    # Select file to be downloaded
    FILE="$(zenity --title "$TITLE" --text "$PROMPT_FILE" --list \
        --column "$FILENAME" --column "$FILEDESC" \
        "ClientesMac_rev34.zip" "macOSX 10.14 o superior" \
        "ClientesLinux_DEB64_Rev25.zip" "Ubuntu 18.04 LTS o superior, Debian 10" \
        "ClientesLinux_CentOS7_Rev6.zip" "CentOS 7" \
        "ClientesLinux_RPM64_Rev24.zip" "Fedora 34 o superior, CentOS Stream 9" \
        --print-column=1)"

    # Set file to be downloaded
    set_file "$FILE"

    # Ask for serial number
    SERIAL="$(zenity --title "$TITLE" --text "$PROMPT_SERIAL" --entry)"
    [ -z "$SERIAL" ] && zenity --title "$TITLE" --text "$PROMPT_ERR_SERIAL" --error && exit 1

    # Generate tempkey & Define DOWNLOAD_URL
    TEMPKEY="$(download_iso "$SERIAL" | sed '/tempkey/!d;s/.*tempkey=//g;s/".*$//g')"
    [ -z "$TEMPKEY" ] && zenity --title "$TITLE" --text "$PROMPT_ERR_DOWNLOAD" --error && exit 1
    DOWNLOAD_URL="https://soportefirmadigital.com/sfdj/getiso.aspx?tempkey=$TEMPKEY"
    
    # Define where to save file
    zenity --title "$TITLE" --text "$PROMPT_DIR_FILE" --info
    SAVE_FILE="$(zenity --file-selection --directory)"
    [ -z "$SAVE_FILE" ] && zenity --title "$TITLE" --text "$PROMPT_ERR_DIR_FILE" --error && exit 1
    SAVE_FILE="$SAVE_FILE/$FILE"

    # Download file & show progress
    (while true ; do 
        DOWN="$(du "$SAVE_FILE" 2>/dev/null | grep -o '^[0-9]*')"
        r=$(((DOWN*10000)/SIZE))
        printf '%d\n' ${r%??}
        sleep 0.5
    done | zenity --title "$TITLE" --text "$PROMPT_DOWNLOAD" --progress) & curl "$DOWNLOAD_URL" -o "$SAVE_FILE"
fi
